########################################################################################
# If our drivers wont compile on your system neither will this                         #
# You should have zaptel sources or fakezap with zaptel installed                      #
# you must modify /lib/rpm/macros to get rid of the unpackaged files terminates build  #
# This is a sample and though it does work we make no gurantees it will work for you   #
# Follow the comments. Anything changible should have a comment of some sort           #
# You should only need to edit the versions, isbeta, and files....                     #
########################################################################################

#Detect the kernel
%{!?kernel: %{expand: %%define kernel %(uname -r)}}

%define kversion %(echo %{kernel} | sed -e s/xen// -) 
%define krelver  %(echo %{kversion} | tr -s '-' '_')
%if %(echo %{kernel} | grep -c xen)
        %{expand:%%define kxensufix -xen}
%endif


###############################################
# firmware <version>                          #                      
# isbeta < 1 = yes 0 = no >                   #
# vers  <rhino version>                       #
# modpath where the modules go...             #
###############################################

%define isbeta 1
%define firmware 1.11 
%define vers 0.99.6
%define extraver b4
%define relver 1.%{extraver}
%define modpath /lib/modules/%{kernel}/extra
%define dahdiver 2.8.0.1
# %define dahdidir /usr/src/dahdi-linux
%define dahdidir /usr
# para definir que es dahdi
%define epoch 2 


Summary: Rhino Telephony Drivers and Utilities
Name: rhino
Version: %{vers}
Release: %{relver}
Epoch: %{epoch}
License: GPL
Group: System Environment/Libraries
URL: http://www.rhinoequipment.com/
Packager: James Finstrom  <james@rhinoequipment.com>
Vendor: Rhino Equipment Corp
Source: http://ftp.rhinoequipment.com/Drivers/Beta/rhino-linux-%{version}%{extraver}.tbz2
Source1: ftp://ftp.rhinoequipment.com/Drivers/Contrib/modprobe.rhino
Source2: install-ceros
BuildRequires: MAKEDEV dahdi-devel >= %{dahdiver}
Requires: dahdi >= %{dahdiver}
# Provides: rhino = %{kernel}-%{version}
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
%if 0%{?fedora}%{?centos_ver}
Requires(pre): /bin/chmod
%else
Prereq: /bin/chmod
%endif

%description -n rhino
Rhino Telephony Drivers and Utilities


%package -n kmod-rhino%{?kxensufix}
Summary: Rhino Telephony interface support
Version: %{version}
Release: %{relver}
Group: System Environment/Libraries
Obsoletes: kernel-module-rhino%{?kxensufix}
Requires: dahdi >= %{dahdiver}
%if 0%{?fedora}%{?centos_ver}
Requires(pre): /sbin/depmod, /sbin/ldconfig
Requires(pre): module-init-tools
Requires(pre): kmod-dahdi%{?kxensufix} >= %{dahdiver}-0
%else
Prereq: /sbin/depmod, /sbin/ldconfig
Prereq: module-init-tools
Prereq: kmod-dahdi%{?kxensufix} >= %{dahdiver}-0
%endif

%description -n kmod-rhino%{?kxensufix}
Kernel Module - Rhino Telephony Drivers for %{kernel} this package should work on dahdi %{dahdiver}

%prep
rm -rf $RPM_BUILD_DIR/rhino-%{version}%{extraver}

%setup -n rhino-linux-%{version}%{extraver}

%build
SKIPWAIT=1 make KVERS=%{kernel} INSTALL_PREFIX=%{buildroot} DAHDI_DIR=%{dahdidir} DAHDI_VER=%{dahdiver}

%install
SKIPWAIT=1 make KVERS=%{kernel} INSTALL_PREFIX=%{buildroot} DAHDI_DIR=%{dahdidir} DAHDI_VER=%{dahdiver} install
mkdir -p %{buildroot}/lib/firmware
cp drivers/rhino/rxt1/*.fw %{buildroot}/lib/firmware/
cp drivers/rhino/r1t1/*.fw %{buildroot}/lib/firmware/
cp drivers/rhino/rcbfx/*.fw %{buildroot}/lib/firmware/

# Installing the modprobe file
mkdir -p %{buildroot}/etc/modprobe.d
cp -a %{SOURCE1} %{buildroot}/etc/modprobe.d/modprobe.rhino.conf

# Installing install-ceros script
mkdir -p %{buildroot}/usr/local/sbin/
cp -a %{SOURCE2} %{buildroot}/usr/local/sbin/

# Collect all kernel modules in extra for weak-updates support
mkdir %{buildroot}%{modpath}
mv `find %{buildroot}/lib/modules/%{kernel}/rhino/ -name *.ko` %{buildroot}%{modpath}
rm -rf %{buildroot}/lib/modules/%{kernel}/rhino/
ls %{buildroot}%{modpath}/*.ko | sed -ne 's:^%{buildroot}::p' > %{buildroot}/lib/modules/%{kernel}/extra/.kmod-rhino-%{version}-%{release}


%clean
%{__rm} -rf %{buildroot}

%post -n kmod-rhino%{?kxensufix}
# The following lines should not be needed in Elastix because the /etc/sysconfig/zaptel is regenerated by
# the hardware detection module
if ! /bin/grep 'rxt1' /etc/dahdi/modules >/dev/null 2>&1; then
 echo '' >> /etc/dahdi/modules
 echo '# Rhino Dual and Quad-span T1/E1/J1 PCI Interface Card' >> /etc/dahdi/modules
 echo 'rxt1' >> /etc/dahdi/modules
fi

if ! /bin/grep 'r1t1' /etc/dahdi/modules >/dev/null 2>&1; then
 echo '' >> /etc/dahdi/modules
 echo '# Rhino Single-span T1/E1/J1 PCI Interface Card' >> /etc/dahdi/modules
 echo 'r1t1' >> /etc/dahdi/modules
fi

if ! /bin/grep 'rcbfx' /etc/dahdi/modules >/dev/null 2>&1; then
 echo '' >> /etc/dahdi/modules
 echo '# Rhino 4/8/12/24 Channel Analog PCI Interface Card' >> /etc/dahdi/modules
 echo 'rcbfx' >> /etc/dahdi/modules
fi

# update the ld database
/sbin/ldconfig

# make sure the kernel knows about the new rhino modules
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} &>/dev/null || :

cat /lib/modules/%{kernel}/extra/.kmod-rhino-%{version}-%{release} | /sbin/weak-modules --add-modules

%preun -n kmod-rhino%{?kxensufix}

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    cp /lib/modules/%{kernel}/extra/.kmod-rhino-%{version}-%{release} /tmp/
fi


%postun -n kmod-rhino%{?kxensufix}
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} &>/dev/null || :

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    cat /tmp/.kmod-rhino-%{version}-%{release} | /sbin/weak-modules --remove-modules
    rm -f /tmp/.kmod-rhino-%{version}-%{release}
fi


%post -n rhino
chmod 0755 /usr/local/sbin/install-ceros

%files -n kmod-rhino%{?kxensufix}
%{modpath}/*.ko
%{modpath}/.kmod-rhino-%{version}-%{release}
/lib/firmware/*.fw
%config
/etc/modprobe.d/modprobe.rhino.conf
%doc

%files -n rhino
/usr/local/sbin/install-ceros

%changelog
* Tue Jan 27 2014 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.6-1.b4
- Attempt to handle CentOS 6 via the centos_ver macro just like a Fedora. 

* Fri Jan 03 2014 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.6-0.b4
- Update to 0.99.6b4
- Recompile for DAHDI 2.8.0.1
- Add .conf extension to modprobe.rhino to avoid warnings.

* Wed May 30 2012 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.6-0.b2
- Update to 0.99.6b2
- Recompile for DAHDI 2.6.1

* Tue Dec 06 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.4-3.rc1
- Include support for kernel module weak updates.

* Mon Aug 15 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.4-2.rc1
- Rebuild to cope with ABI change from dahdi-2.4.1.2-4

* Tue Apr 26 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.4-1.rc1
- Rebuild against dahdi-2.4.1.2
- Fix specfile to install firmware without using absolute paths

* Wed Oct 27 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.4-0.rc1
- Update to 0.99.4rc1
- Rebuild against dahdi-2.4.0

* Tue Jun 29 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.3-2.beta2
- Rebuild against dahdi-2.3.0.1
- Patch to prevent kernel backtrace on hardware detection. Based on similar
  fix from wanpipe drivers.

* Mon Mar 01 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.3-1.beta2
- Rebuild against dahdi-2.2.1 and updated kernel

* Wed Dec 09 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.3-0.beta2
- Update to 0.99.3-beta2

* Thu Jul 23 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99.2-0
- Rebuild against dahdi-2.2.0.1

* Tue May 12 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99-1.4
- Fix %%post and add %%postun so that depmod is run against the target
  kernel rather than the currently running kernel.

* Mon Mar 09 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99-1.3
- Fix dependency on kernel-module-dahdi-devel (remove xen)

* Mon Mar 03 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 0.99-1.2
- Fix spec to produce correct SRPM name

* Mon Feb 16 2009 Alex Villacis Lasso <a_villacis@palosanto.com>
- Replace ztcfg with dahdi_cfg in modprobe.rhino 

* Tue Feb 03 2009 Alex Villacis Lasso <a_villacis@palosanto.com>
- Require package kernel-module-zaptel-devel instead of installed source RPM
- Fix compilation with kernel source other than running kernel

* Mon Jan 02 2009 Bruno Macias <bmacias@palosanto.com> 0.99.1-1
- Changed zaptel to dahdi.
- Changed in format versions in this rpm. Rhino sources have changed of name and versions.
- Best implementation in this spec more variables.
- Parameter epoch defined

* Mon Nov 10 2008 Bruno Macias <bmacias@palosanto.com> 2.2.6-9
- Update the kernel to 2.6.18-92.1.17.el5.
- Update zaptelver 1.4.12.1

* Fri Sep 28 2008 Bruno Macias <bmacias@palosanto.com> 2.2.6-8
- Add Prereq /bin/chmod

* Tue Aug 19 2008 Edgar Landivar <e_landivar@palosanto.com> 2.2.6-2
- Including install-ceros script

* Mon May 19 2008 Edgar Landivar <e_landivar@palosanto.com> 2.2.6-1
- Updating to 2.2.6 version

* Thu Apr 10 2008 Edgar Landivar <e_landivar@palosanto.com> 2.2.5.3-1
- Updating to 2.2.5.3 version

* Tue Feb 26 2008 Edgar Landivar <e_landivar@palosanto.com> 2.2.5-1
- Updating to 2.2.5 version

* Tue Feb 26 2008 Edgar Landivar <e_landivar@palosanto.com> 2.2.4-1
- Updating to 2.2.4 version

* Mon Feb  4 2008 Edgar Landivar <e_landivar@palosanto.com> 2.2.3-1
- Updating to 2.2.3 version

* Wed Nov 29 2007 Edgar Landivar <e_landivar@palosanto.com> 2.2.1-3
- Fixed a bad reference to the zaptel sources

* Tue Nov 13 2007 Edgar Landivar <e_landivar@palosanto.com>
- Applied changes to compile in the RPM builder server from the Elastix project

